# Variables CI/CD nécessaires :
#  * PROGET_FNACNUGET : feed nuget de publication
#  * PROGET_API_KEY : clé d'accès à Proget
#  * SONAR_URL : URL du serveur SonarQube
#  * SONAR_USER : Utilisateur SonarQube autorisé à publier une analyse
#  * SONAR_PASSWORD : Mot de passe de l'utilisateur SonarQube

# Modifier la variable SONAR_PROJET_KEY sur le job build_job pour l'adapter au contexte

stages:
  - build
  - test
  - publish
  - release

include:
  - project: 'fnacdarty/fdps/dev/teams/architecture/gitlab-templates'
    file: 'dotnet.yml'

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH

build_job:
  stage: build
  extends: .build_dotnet
  variables:
    SONAR_PROJECT_KEY: df-fnacproduit-FnacDarty.fnacdirect.services.checkout.nav

test_job:
  stage: test
  extends: .test_dotnet

# Le package Nuget est publié :
#  * Systématiquement lors du build déclenché par la pose d'un tag
#  * A la demande lors du build déclenché par un commit sur une branche  
#  * Jamais lors des builds de MR
publish_nuget:
  stage: publish
  extends: .publish_nuget
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: $CI_COMMIT_TAG
      when: on_success
    - if: $CI_COMMIT_BRANCH
      when: manual
      allow_failure: true
    - when: never
  dependencies:
    - build_job

release:
  stage: release
  extends: .release
  rules:
    - if: $CI_COMMIT_TAG
      when: on_success
  dependencies:
    - publish_nuget
